<script lang="ts">
  import { cardSuit } from "../utils";
  import SuitIcon from "./SuitIcon.svelte";

  export let card: Card;

  let suit = cardSuit(card);
  $: suit = cardSuit(card);

  let [bgColor1, bgColor2] = getBgColors(suit);
  $: [bgColor1, bgColor2] = getBgColors(suit);

  function getBgColors(suit: Suit): [string, string] {
    switch (suit) {
      case "A":
        return ["hsl(50deg 90% 80%)", "hsl(50deg 90% 77%)"];
      case "B":
        return ["hsl(340deg 90% 93%)", "hsl(340deg 90% 90%)"];
      case "C":
        return ["hsl(20deg 100% 80%)", "hsl(20deg 100% 77%)"];
      case "D":
        return ["hsl(242deg 60% 90%)", "hsl(242deg 60% 87%)"];
      case "E":
        return ["hsl(148deg 60% 85%)", "hsl(148deg 60% 82%)"];
      case "F":
        return ["hsl(34deg 50% 85%)", "hsl(34deg 50% 82%)"];
      case "G":
        return ["hsl(0deg 0% 85%)", "hsl(0deg 0% 82%)"];
      case "H":
        return ["hsl(100deg 38% 75%)", "hsl(100deg 38% 72%)"];
      default:
        return ["linen", "linen"];
    }
  }
</script>

<div class="wrapper shadow">
  <div
    class="inner"
    style:--bg-color-1={bgColor1}
    style:--bg-color-2={bgColor2}
  >
    <div class="corner">
      <SuitIcon {suit} />
    </div>
    <div class="center">
      <SuitIcon {suit} />
    </div>
  </div>
</div>

<style>
  .wrapper {
    background-color: snow;
    position: relative;
    width: 10em;
    height: 14em;
    border-radius: 7% / 5%;
    border: 0.05em solid #0002;
  }

  .inner {
    background: radial-gradient(var(--bg-color-1), var(--bg-color-2));
    border: 0.05em solid #0002;
    border-radius: calc(7% * 0.5) / calc(5% * 0.5);
    position: absolute;
    top: calc(5% * 0.67);
    bottom: calc(5% * 0.67);
    left: calc(7% * 0.67);
    right: calc(7% * 0.67);
  }

  .corner {
    font-size: 2em;
    position: absolute;
    left: 0;
    top: 0.125em;
  }
  .center {
    font-size: 5.5em;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
</style>
